# WebView加速方案

### 前言

现在H5开发对移动终端的重要性不必多提，但H5在native中有很明显的缺陷，比如首次白屏、要等很久的loading等，那我们怎么提高性能体验呢？首先我们要分析，耗时占比的大头是哪一块？是WebView容器初始化太慢？还是资源太多下载太慢？还是渲染太久？市面上主流的方案都是打组合拳，全栈手段优化达到最优，

### 博文

- [WebView性能、体验分析与优化](https://tech.meituan.com/2017/06/09/webviewperf.html)
> 非常清晰的思路，从打开一个WebView经历的阶段开始，逐个攻破优化。

- [70%以上业务由H5开发，手机QQ Hybrid 的架构如何优化演进？](https://mp.weixin.qq.com/s/evzDnTsHrAr2b9jcevwBzA)
> 在快速的Web运营节奏和高性能的要求下，QQ团队采用动态CDN、后台渲染等全栈手段优化体验，也构建了围绕速度、成功率、页面异常等维度的监控体系来保障服务质量。

- [iOS 性能优化 -- H5离线秒开](https://juejin.im/post/5cd4fda8f265da03a00febe1)
> 方案优劣比对和选型，各有利弊，没有最好的方案，只有最适合的方案。

### 库

- [VasSonic](https://github.com/Tencent/VasSonic)
> 静态直出+动静分离，优化到WebView性能极点。

- [CacheWebView](https://github.com/yale8848/CacheWebView)
> 相比起VasSonic的成本，CacheWebView是对小公司更为友好的方案，本地资源+利用OkHttp自带的缓存，上手超快。

 