# 代码质量与代码规范

### 前言

作为一个强迫症，代码优雅可读是我持续的追求。我认为每个开发都应该对代码负责，对于整体的系统而言，既需要宏观上的架构设计，也必须重视微观上的代码细节。

### 一、代码质量

#### 博文

- [关于烂代码的那些事（上）](http://blog.2baxb.me/archives/1343)
- [关于烂代码的那些事（中）](http://blog.2baxb.me/archives/1378)
- [关于烂代码的那些事（下）](http://blog.2baxb.me/archives/1499)
> 相当赞的系列文，幽默风趣。作者带着我们了解什么是烂代码？烂代码产生的原因到底是什么？如何尽可能高效和客观的评价代码的优劣？如何去重构代码？

- [在Java中如何优雅地判空](https://juejin.im/post/5bf60e286fb9a049dd7fe9f8#comment)
> 如果你不想繁琐地到处 !=null，本文有些新思路可以借鉴下。

- [也谈代码 —— 重构两年前的代码](https://www.jianshu.com/p/0e31122c38f7)
> 作者讨论了为什么要重视代码？为什么有烂代码？如何保持代码的优雅？总结了八个小技巧，让你代码质量上一个台阶。

- [重构代码的Tricks](https://www.villianhr.com/2017/09/25/重构代码的Tricks)
> 重构的手段不是只有大而全的设计模式，我们可以学些精巧、随处使用的小技巧，来逐步改善代码。

- [如何提高代码的可读性? - 读《编写可读代码的艺术》](https://www.jianshu.com/p/422657e71e3a)
> 编写可读代码的艺术，既然是艺术，说明我们需要不断追求，不断精益。既然可读，说明代码的写法应当使别人理解它所需要的时间最小化。本篇读后感，不仅展示了书中的观点，还加入了作者的思考：如果你连编程里这种最小的事情都不好好做，那你又怎么证明你对编程是有追求的呢？

#### 书籍

- 《重构》
- 《代码整洁之道》
- 《代码模式》
- 《修改代码的艺术》
- 《编写可读代码的艺术》

> 经典书籍还用我介绍吗？一句话，读就完了呗！

### 二、代码规范

#### 博文

- [一种成功的xml资源命名规范](https://www.jianshu.com/p/e3c7fa7d837b)
> A successful XML naming convention 的译文。作为Android开发，相信你肯定遇到过资源文件疯涨的情况，就算同一个控件，团队成员的命名都是五花八门。这篇文章给了一个不错的模式参考，让我们一起把命名这个小细节做好吧！

#### 书籍

- [阿里巴巴Android开发手册_v1.0.1](https://github.com/feelschaotic/AndroidKnowledgeSystem/tree/master/10.%20T型成长/团队管理/阿里巴巴Android开发手册_v1.0.1.pdf)
> 以开发者为中心视角分为Java语言规范（遵循《阿里巴巴Java开发手册》），Android资源文件命名与使用，Android基本组件，UI与布局，进程、线程与消息通信，文件与数据库，Bitmap、Drawable与动画，安全以及其他等九大部分。  
>
> 虽说陷入了抄袭门，还是有点可取之处，可以视实际开发情况取精华去糟粕。