# 架构的思考

## 前言

有的小伙伴可能会很苦恼，架构思维到底要如何培养？如何提升自己做架构的感觉？这里给出我一些小小的建议：

0. 工具箱  
先完善自己的加速框架，也就是不断补充知识库和工具库，达到拎起就用。

1. 勤于思考  
  在编码之前，逼迫自己一定要做结构、层次分析。
2. 多沟通  
  无论是组员还是 leader，无论是设计还是产品，往往灵感一触即发。
3. 多读  
  多看看第三方的源码，思考为什么作者这样设计，这样做有什么好处和坏处，如果我来做，我会怎么做？可以做得更好？别犹豫了，赶紧提个 pr。这里的 多读，不局限于己端，比如搞客户端也可以看看 vue、Rect。
4. 垂直领域和宽度领域兼顾  
  见得多才能更全面的分析，大部分时候需要联动各端才能达到最好的效果。

## 讲烂了的 MVC、MVP、MVVM 家族

- [iOS应用架构谈 view层的组织和调用方案](https://casatwy.com/iosying-yong-jia-gou-tan-viewceng-de-zu-zhi-he-diao-yong-fang-an.html)
> 读来让人眼前一亮！虽然文章时间有些久远，谈的也是 iOS 下的场景，但是丝毫不影响 Android 开发者参考。技术没有好坏之分，只有适不适合，一个新概念新技术的提出，必定是为了解决某种特定场景下的问题，社区中就常常有这样的声音，到底 MVP 比 MVVM 更好吗？MVC、MVP、MVVM，我到底该怎么选？在搞懂这些问题前，你首先要做的是，阅读本文，了解这些架构思想都是在什么场景下诞生的。

- [是让人 提神醒脑 的 MVP、MVVM 关系精讲！](https://juejin.im/post/6846687603547176974)
>  本文重新厘清了容易混淆的概念，对初学者来说，要命的不是层出的新名词新概念，而是在缺少鉴别能力情况下，被错误的博文带入弯路！   
>  ⚠️ 小注意：Jetpack ViewModel 并不等价于 MVVM ViewModel。
>  MVVM ViewModel 是 MVVM 架构中的一个角色，看不见摸不着只是一种思想。
>  而 Jetpack ViewModel 是一个实实在在的框架用于做状态托管，有对应的作用域可跟随 Activity/Fragment 生命周期，但这种特性恰好可以充当 MVVM ViewModel 的角色，分隔数据层和视图层并做数据托管。
>  所以结论是 Jetpack ViewModel 可以充当 MVVM ViewModel 但二者并不等价

## 思考衍生

- [精通那么多技术为何还是做不好一个项目？](https://zhuanlan.zhihu.com/p/108341436)
> 相信不少小伙伴都被历史债务折磨得遍体鳞伤，我们不时会想：如果可以从头推翻重做就好了、如果让我重新设计、如果可以重构一下…… 真如此，我们有足够的前瞻性设计好灵活性吗？有不断保持小重构避免项目腐化的质量职业素养吗？为什么每每项目后期质量脱缰失去控制？本文试图总结出，腐化项目普遍存在的共性问题并给出相应的解决方案，读来让人深思。
