# Glide

## 如何学习 Glide？

`glide`是一个非常优秀的开源库，源码复杂，功能强大。

![](https://s2.ax1x.com/2020/01/08/lRFqgO.png)

如图所示，`glide`不仅仅只有图片加载功能，那这么多知识点，怎么学呢？

我建议，源码可以多读几遍，**每次读的目的都不一样**，比如第一次读主要看图片加载，第二次读主要看缓存策略，第三次读看设计模式的运用等等，读之前心中一定要准备好几个问题，自问自答。

1. 如何**加载**出图片 —— 图片加载流程

2. 如何**高性能**加载图片 —— 缓存和复用

3. 如何**节省内存**加载图片 —— 生命周期管理

4. 如何让业务方**好扩展、方便调** —— 设计模式

5. 如何运用在我们**其他开发场景**中 —— 带来的思考和启示
我们不是读懂`glide`就可以了，优秀的设计思想是通用的。

## 优势

我觉得`glide`最大的优势在于灵活，缓存策略有多种，可以缓存多种规格多种尺寸，支持多种类型，还能自定义 缓存策略，所有的 SDK 开发者都应该向 `glide` 学习。

## 博文
- [面试官：简历上最好不要写Glide，不是问源码那么简单](https://juejin.im/post/5dbeda27e51d452a161e00c8)
> 在面试中，遇到图片加载问题的频率一般很高，如果面试官问你：你自己写个图片加载框架，你会考虑哪些问题？你怎么回答？诶诶诶，先别看文章，自己自问自答一下，想不出来了？看看本文能给你带来什么启发吧。

- [Android图片加载框架最全解析（一），Glide的基本用法](https://blog.csdn.net/guolin_blog/article/details/53759439)
- [Android图片加载框架最全解析（二），从源码的角度理解Glide的执行流程](https://blog.csdn.net/guolin_blog/article/details/53939176)
> 郭霖大神的博文思路写得特别好，清晰流畅，非常适合初次解析Glide源码的小伙伴。

