# SparseArray

## 关键词

双数组、引入DELETE标记删除O(1)、二分查找、避免自动装箱、满了才扩容、优化追加元素可直接追在数组末尾

## 前言

`SparseArray`相比起`HashMap`来说，源码简单得多。

我们首先要清楚 `SparseArray`的诞生背景和应用场景，这将影响它的特点。我们知道，谷歌官方推荐在 Android 开发中，使用`SparseArray`代替`HashMap`，那反过来想想，`HashMap`有什么缺点呢？

1. 内部负载因子扩容，意味着 1 - 负载因子剩下的空间永远不会用来放元素，浪费空间！
2. Map 的 key value 需要使用包装类型，装箱操作会创建对象，如果频繁的装箱操作会消耗许多内存。

那`SparseArray`又是怎么解决这个问题的呢？一切答案尽在下面的博文中。

## 博文

- [[原创]面试还在问 SparseArray？记住 3 句话让你临时把佛脚抱好！](https://juejin.im/post/5da1481e6fb9a04de96e8b72)
> 这篇文章让我想起了一种学习方式，就是压缩知识信息，提炼出关键词，再牢牢记住，这样可以减少记忆量，且以后需要用到，可以用关键字推导出来，本文就是用这种关键字的方式来开篇阐述，写作技巧值得学习！