# 集合这么多，我该怎么掌握？

想要掌握集合，必须先知道，为什么会有集合，集合的诞生背景是什么呢？

想想如果用数组：

- 长度固定，满了需要自己copy扩容
- 需要自己记录实际存储元素，毕竟length只拿到了array的容量
- 只能存放同一类型
- 数组不是面向对象

用起来是不是不那么顺手？集合就是在这种情况下应运而生。

不同的集合要解决的问题不一样，这么多类，别死记硬背，根据场景+类前后缀来区别。

- 想要映射关系？一律找Map后缀，映射关系的元素需不需要有序？有序是怎么个有序法？按插入顺序还是访问顺序？那我们可以在Map分类下找LinkedHashMap或TreeMap.
- 只存Value又要有序？使用List集合容器！
- 去重？使用Set集合！想要去重又有序？TreeSet！

集合是为数据和业务服务的，对外就是增、删、改、查，对内包含初始化、数据的维护、动态扩容等等细节。

在学习集合时，我们应该保持一个清晰的主线，只关注几个重要的问题：

1. 它解决了什么数据问题？
2. 它如何解决这些问题？
3. 为了解决这些问题，引入了什么新的问题，它是如何平衡的？

程序的世界里，没有银弹，否则其他集合就没有了存在的必要。也就是说每个集合一定有不同的侧重点，它在时间和空间上，一定是有所取舍，有所平衡，在这个目标下，做出最合适的优化实现。

![](https://s2.ax1x.com/2020/01/08/lRFKje.jpg)


