# 热修复

### 前言

国内没有统一的应用市场造成了热修复的流行 —— 热修复就是源于版本更新繁琐、不及时等等痛点应运而生。

热修复只能在国内市场使用，Google Play 是过不了谷歌审核那关的。Google Play 的发布审核速度快，并且自带好用的 Alpha Beta 测试以及灰度发布，在很大程度上能替代热修复带来的便捷。

苹果和谷歌一直在坚定的推动 Web 技术，在热更新和插件化的道路选择上，我们和国外走得越来越远，这真的是一件好事情吗？我们是否走了弯路？

### 书籍

- [《深入探索Android热修复技术原理》](https://github.com/feelschaotic/AndroidKnowledgeSystem/tree/master/7.%20进阶/动态化/深入探索Android热修复技术原理.pdf)
> 毫不夸张地说，看完这本书热修复原理你就掌握七七八八了。
>
> 市面上深入系统地讲解热修复技术细节的书籍基本没有，市面上国内外的各种 Android 书籍大部分只是泛泛地囊括 Android 开发的基础知识，然而基本都没有包含热修复技术的章节，最多只是一笔带过。即使有很多开源的热修复方案，要自己硬啃代码还是要花费不少时间和精力。与其看一个晦涩难懂的项目，不如找一本专业详实的书，这将会帮你更系统全面地理解热修复涉及的难点与关键点。

### SDK热修复

> 目前市面上成熟的商业热更新方案不少，但只适用于 App 热更新，那如果 SDK 开发者想要支持热更新呢？SDK热更新，这是一个极少被关注的问题，全网相关的文章甚少。推荐篇好文，希望可以给你带来新思路。

- [APP 热修复都懂了，你会 SDK 热修复吗？最全方案在这里！](https://www.jianshu.com/p/f4c311612a01)
> 全网最全的 SDK 热修复方案！

- [教你如何在SDK开发使用美团Robust进行热更新](https://juejin.im/post/5a0129926fb9a0452724fea6)
> 非常详尽地阐述了改造的思路和方法，强烈推荐！