<p align='center'>
<img src='https://i.loli.net/2020/01/08/7HURql4otzYPivh.jpg'>
</p>

<p align='center'>
<a href="https://www.jianshu.com/u/79087863dce7"><img src="https://img.shields.io/badge/%E7%AE%80%E4%B9%A6-@FeelsChaotic-CD6839.svg?style=flat&colorA=ed6f59"></a>
<a href="https://juejin.im/user/58130890bf22ec0068821df3"><img src="https://img.shields.io/badge/%E6%8E%98%E9%87%91-@FeelsChaotic-00cccc.svg?style=flat&colorA=1970fe"></a>
</p>

<p align='left'>
  <strong>For English version,<a href="https://github.com/feelschaotic/AndroidKnowledgeSystem/blob/master/README_EN.md"> please click here.</a></strong>
</p>

# TheMostCompleteAndroidKnowledgeSystemAndRealStuff

你想要的最全 Android 进阶路线知识图谱 + 干货资料收集，一条龙解决「查漏 -> 搜索资料 -> 专项学习 -> fix 短板」的闭环，[点此开启阅读吧！](https://feelschaotic.gitbook.io/android-knowledge-system/)

# 一、为什么有这个项目？

对于读者来说，相信大家在学习时常常困惑：

- 困惑1：网上这么多的资料和博文，眼花缭乱又不成体系，水文和复制粘贴的文章太多，筛选的工作量实在是太大了，我怎么**又快又好地找到我想要的文章**呢？

- 困惑2：怎么不同的博文观念冲突，我该以哪篇为准呢？

- 困惑3：怎么学都学不进去，是不是方法不对呢？这个知识点该怎么学？我怎么才能**提高学习效率**呢？

对于笔者来说，这是一个松鼠症患者的自我治疗，强迫自己有输出有咀嚼有复盘。也借此提醒大家，不要被列表（图谱）所累，只需学习基础知识并开始开发某个项目，其余的学习就会随之而来。

所以我萌生写一篇 Android 进阶知识图谱的想法，**有体系有方向有资料，既可以做一个整体的梳理，也可以专项查漏补缺。** 如果你是 Android 初学者，不善于搜索或不知道如何入手一个新知识点，那么我相信这份列表，将会**成为你的首选**。如果你是 Android 老手，相信这份列表，也会**成为你专项复习的有力辅助**。

**本项目会不断更新**，直到我头发掉光为止（手动狗头）。

> 当然，受限于个人水平，有错误请多多指正，对于某个问题你有更好的 Tips，欢迎提个 Issues 或者 pr，诚邀你和我一起成长，欢迎一起来维护这个项目！


# 二、和别的知识体系有什么区别？

- 一个字，**最全面**
- 这不是一个简单的知识体系，每个知识点都有**详细的导读**  
![](https://i.loli.net/2020/01/08/ABQPqLyZaFpwlCO.png)

  ![](https://i.loli.net/2020/01/08/xCf6vmsyqijko3u.png)

  ![](https://i.loli.net/2020/01/08/uN3BLiJ1GzRyXYE.png)

- 这不是一个简单的知识概述，每个知识点都有**学习方法和顺序指引**  
![](https://i.loli.net/2020/01/08/jwalUBVmIFCAbDN.png)

- 这不是一个简单的资源收集项目，每篇资料都有**闪亮的优点**  
![](https://i.loli.net/2020/01/08/E9n73gaTDRylkus.png)

  ![](https://i.loli.net/2020/01/08/EhzDJgoXZtM45Ga.png)


# 三、你能得到什么？

- 对 Android 知识体系**完整的掌握**
- 建立碎片化知识点的**关联**
- 节省时间，**快速找到**优秀的专项博文
- 推广导流，**欢迎投稿**自己优秀的博文，万一这个项目火了呢？（斜眼笑）

---

# Android 最全知识体系图谱

![](https://i.loli.net/2020/01/08/AheRqs2ZaWGYyIx.png)

> [想要获取其他格式？请戳](https://github.com/feelschaotic/AndroidKnowledgeSystem/tree/master/Android知识体系图谱)

**图谱可能存在更新不及时的情况，请以目录文件`SUMMARY.md`为准**

# GitBook

以 GitBook 电子书的形式来展现本项目，阅读体验好，界面清爽又方便管理，[马上开启阅读吧！](https://feelschaotic.gitbook.io/android-knowledge-system/)

![](https://s2.ax1x.com/2020/01/09/lfQc24.md.png)

> - 添加 gitbook-plugin-search-pro 插件支持中文搜索
> - 添加 Splitter 插件支持 GitBook 侧边栏目录的宽度可以自由调节

你还可以 clone 项目生成 PDF 格式的电子书：
> $ gitbook pdf ./ ./mybook.pdf

生成 epub 格式的电子书：
> $ gitbook epub ./ ./mybook.epub

生成 mobi 格式的电子书：
> $ gitbook mobi ./ ./mybook.mobi


# 维护计划

## 诚邀你参与翻译计划

本项目登上趋势榜单后受到**各地开发者**的关注。

![](https://i.loli.net/2020/01/08/28NiJmeg9bjOSQI.png)

![](https://i.loli.net/2020/01/04/xUMVP9TKCRZiWjb.png)

遗憾的是目前只有中文版本，诚挚邀请各位小伙伴，**一起参与英文版的制作**（身为英语渣渣的痛~）。

> 想了解如何参与翻译计划？这里有份[翻译计划参与指南送上](https://github.com/feelschaotic/AndroidKnowledgeSystem/wiki/%E7%BF%BB%E8%AF%91%E8%AE%A1%E5%88%92%E5%8F%82%E4%B8%8E%E6%8C%87%E5%8D%97)。

## 诚邀你一起维护

术业有专攻，你可以自由**选择**知识体系里擅长或感兴趣的知识点，编写导读、学习方式和资料推荐。**写下来本身就是一个促进思考整理的过程喔！**

> 想了解如何参与维护？这里有份[维护参与指南送上](https://github.com/feelschaotic/AndroidKnowledgeSystem/wiki/%E7%BB%B4%E6%8A%A4%E5%8F%82%E4%B8%8E%E6%8C%87%E5%8D%97)。

## 更新计划

更新计划请见[看板](https://github.com/feelschaotic/AndroidKnowledgeSystem/projects/1)

大家可以留言，说下希望看到哪些知识点，优先更新。更新情况见`SUMMARY.md`，有`md`链接的即为更新完成。

## 联系方式

如果你
- **热爱**开源
- 希望为**开源**贡献一份力量
- 有好的**优化想法**和**写作建议**
- 想向我**提问**

**请扫码进群与我联系，奥利给！**

![](https://i.loli.net/2020/01/04/XTL5nBNpcfyQskt.jpg)

![](https://s2.ax1x.com/2020/01/14/lq185F.jpg)

# Contributors

<table id='team'>
    <tr>
        <td id='KamiyamaSatoru'><a href='https://github.com/KamiyamaSatoru'><img src='https://avatars2.githubusercontent.com/u/59816048?s=460&v=4' width="150px" height="150px"></a>
            <h4 align='center'><a href='https://blog.csdn.net/KamiyamaSatoru'>神山識 KamiyamaSatoru</a></h4>
        </td>
        <td id='muboluo'><a href='https://github.com/muboluo'><img src='https://avatars3.githubusercontent.com/u/16324311?s=460&v=4' width="150px" height="150px"></a>
            <h4 align='center'><a href='https://www.jianshu.com/u/2bbfed3d5132'>muboluo</a></h4>
       </td>
    </tr>
</table>

# ©️ 转载

<a rel="license" href="http://creativecommons.org/licenses/by/4.0/"><img alt="知识共享许可协议" style="border-width:0" src="https://i.creativecommons.org/l/by/4.0/88x31.png" /></a><br />本<span xmlns:dct="http://purl.org/dc/terms/" href="http://purl.org/dc/dcmitype/Text" rel="dct:type">作品</span>由 <a xmlns:cc="http://creativecommons.org/ns#" href="https://github.com/feelschaotic/AndroidKnowledgeSystem" property="cc:attributionName" rel="cc:attributionURL">FeelsChaotic</a> 创作，采用<a rel="license" href="http://creativecommons.org/licenses/by/4.0/">知识共享署名 4.0 国际许可协议</a>进行许可。
